Package: BiocPkgDash
Type: Package
Title: An interactive Shiny dashboard for Bioconductor package
        maintainers
Version: 1.1.0
Authors@R: c(
  person(
    "Marcel", "Ramos", , "marcel.ramos@sph.cuny.edu", c("aut", "cre"),
    c(ORCID = "0000-0002-3242-0582")
  ),
  person("Vincent", "Carey", , "stvjc@channing.harvard.edu", "aut")
  )
Description: This package provides an interactive Shiny dashboard for
  Bioconductor package maintainers. It visualizes various package statuses,
  metadata, and development metrics, offering insights into package health and
  activity. This tool aims to support maintainers of multiple packages by
  filtering packages via maintainer email.
Depends: R (>= 4.6.0), shiny
Imports: BiocBaseUtils, BiocPkgTools (>= 1.27.6), BiocManager, bsicons,
        bslib, dplyr, DT, ggplot2, gh, htmlwidgets, plotly, rmarkdown,
        shinybiocloader, shinyjs, tibble, tidyr, utils, whisker, yaml
Suggests: BiocStyle, knitr, sessioninfo, tinytest
biocViews: Software, Infrastructure, Visualization, GUI
VignetteBuilder: knitr
License: Artistic-2.0
Encoding: UTF-8
URL: https://github.com/Bioconductor/BiocPkgDash
BugReports: https://github.com/Bioconductor/BiocPkgDash/issues
RoxygenNote: 7.3.3
Roxygen: list(markdown = TRUE)
Date: 2026-03-23
git_url: https://git.bioconductor.org/packages/BiocPkgDash
git_branch: devel
git_last_commit: 489cd3b
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 21:30:42 UTC; biocbuild
Author: Marcel Ramos [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-3242-0582>),
  Vincent Carey [aut]
Maintainer: Marcel Ramos <marcel.ramos@sph.cuny.edu>

# BiocPkgDash

# Introduction

The BiocPkgDash package provides an interactive Shiny application to
visualize the status of Bioconductor packages. Primarily, users can
filter packages by maintainer email to display a status badge wall for
all packages maintained by that email. It allows users to filter
packages based on various criteria, such as Bioconductor version,
package type, and GitHub topics. The dashboard displays badges
indicating the build status and code coverage for each package. The tool
is primarily designed for Bioconductor package maintainers to monitor
the status of their packages.

## Comparison to Bioconductor Build Results

The Bioconductor Build Results
[page](https://bioconductor.org/checkResults) provides a comprehensive
overview of the build status of all Bioconductor packages. However, it
can be overwhelming for maintainers who are only interested in the
status of their own packages. The `BiocPkgDash` dashboard provides a
more focused view of the status of packages maintained by a specific
email, allowing maintainers to quickly identify any issues with their
packages without having to navigate through the entire list of packages
on the Build Results page.

Users can quickly go the relevant section in the Bioconductor Build
Results page by clicking on the badges or the status bars in the
dashboard. This allows maintainers to easily access more detailed
information about the build status of their packages.

# Installation

``` r
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("BiocPkgDash")
```

# Loading

``` r
library(BiocPkgDash)
```

Note that the app uses
*[BiocPkgTools](https://bioconductor.org/packages/3.23/BiocPkgTools)* to
download package information from the Bioconductor Build System (BBS)
database. This is required for the app to function properly and can be
safely created. The prompt may look like the following (path varies by
operating system):

    /Users/user/.cache/R/BiocFileCache
        does not exist, create directory? (yes/no): yes

Create the cache directory by entering `yes` and pressing `Enter`.

# Dashboard display

``` r
BiocPkgDash()
```

<img src="man/figures/BiocPkgDash.png" alt="" width="100%" />

Note that the dashboard and this document is organized by the tab
panels. Each tab in the dashboard is described in the following
sections.

## Filtering packages

One can filter packages by name, Bioconductor version, biocViews package
type, maintainer email, and GitHub topics. The dashboard will display
the status badges for all packages that match the selected criteria.
Typically, a user with use one of the methods to filter for packages.
Primarily, the user will filter by the relevant maintainer email.

<img src="man/figures/BiocPkgDash_filter.png" alt="" width="100%" />

### GitHub topic filter

The GitHub topic filter allows users to filter packages based on
specific topics associated with R / Bioconductor packages on GitHub.
This can be useful for organizations that maintain multiple packages
related to a specific project, theme, or grant. For example, one can
filter for all packages related to a particular grant code, e.g.,
“u24ca289073”. Note that repositories will have to have the topic added
to them for the filter to work.

# Badges

The badge wall displays the build status and code coverage for each
package. Clicking on a badge will take you to the relevant page for more
details.

<img src="man/figures/BiocPkgDash_badges.png" alt="" width="100%" />

Note that the coverage badges can be turned off if the maintainer does
not use codecov.io for testing package coverage.

## Downloading the badge wall

The dashboard allows users to download the badge wall as a partial HTML
file. This can be useful for including the badges on personal websites
or other HTML documentation. The HTML file is generated on the fly by
the `shiny` app after clicking the `Download HTML` button on the sidebar
panel.

# Status

The dashboard also provides a visualization of the package build
statuses across different stages of the Bioconductor Build System (BBS).
This helps maintainers quickly identify any issues with their packages.

<img src="man/figures/BiocPkgDash_status.png" alt="" width="100%" />

Note that clicking on any of the status bars in the plot takes the user
to the detailed build report for that specific builder, stage, and
status combination.

# Dependencies

The `Dependencies` tab displays the package reverse dependencies for a
selected package. This can help maintainers understand the dependency
tree of their packages and identify any potential issues.

# Metadata

The `Metadata` tab displays additional information about the selected
package(s) such as the package title, version, and additional fields
from the `DESCRIPTION` file as obtained from the internal `biocViews`
database. This can help maintainers quickly access information about
their package(s).

# Session Information

``` r
sessionInfo()
#> R Under development (unstable) (2025-10-28 r88973)
#> Platform: x86_64-pc-linux-gnu
#> Running under: Ubuntu 24.04.4 LTS
#> 
#> Matrix products: default
#> BLAS/LAPACK: /usr/lib/x86_64-linux-gnu/openblas-pthread/libopenblasp-r0.3.26.so;  LAPACK version 3.12.0
#> 
#> locale:
#>  [1] LC_CTYPE=en_US.UTF-8       LC_NUMERIC=C               LC_TIME=en_US.UTF-8       
#>  [4] LC_COLLATE=en_US.UTF-8     LC_MONETARY=en_US.UTF-8    LC_MESSAGES=en_US.UTF-8   
#>  [7] LC_PAPER=en_US.UTF-8       LC_NAME=C                  LC_ADDRESS=C              
#> [10] LC_TELEPHONE=C             LC_MEASUREMENT=en_US.UTF-8 LC_IDENTIFICATION=C       
#> 
#> time zone: America/New_York
#> tzcode source: system (glibc)
#> 
#> attached base packages:
#> [1] stats     graphics  grDevices utils     datasets  methods   base     
#> 
#> other attached packages:
#> [1] BiocPkgDash_0.99.39 shiny_1.12.1        colorout_1.3-2     
#> 
#> loaded via a namespace (and not attached):
#>  [1] tidyselect_1.2.1     viridisLite_0.4.2    dplyr_1.1.4          farver_2.1.2        
#>  [5] blob_1.2.4           filelock_1.0.3       S7_0.2.1             bitops_1.0-9        
#>  [9] fastmap_1.2.0        RCurl_1.98-1.17      lazyeval_0.2.2       gh_1.5.0            
#> [13] BiocFileCache_3.1.0  BiocPkgTools_1.29.2  promises_1.5.0       XML_3.99-0.20       
#> [17] digest_0.6.39        timechange_0.4.0     mime_0.13            lifecycle_1.0.4     
#> [21] processx_3.8.6       RSQLite_2.4.5        magrittr_2.0.4       compiler_4.6.0      
#> [25] rlang_1.1.6          tools_4.6.0          igraph_2.2.1         yaml_2.3.12         
#> [29] data.table_1.18.2.1  knitr_1.51           htmlwidgets_1.6.4    bit_4.6.0           
#> [33] curl_7.0.0           xml2_1.5.1           RColorBrewer_1.1-3   rsconnect_1.7.0     
#> [37] websocket_1.4.4      purrr_1.2.0          BiocGenerics_0.57.0  grid_4.6.0          
#> [41] stats4_4.6.0         xtable_1.8-4         ggplot2_4.0.1        scales_1.4.0        
#> [45] dichromat_2.0-0.1    cli_3.6.5            rmarkdown_2.30       generics_0.1.4      
#> [49] otel_0.2.0           rstudioapi_0.18.0    httr_1.4.7           tzdb_0.5.0          
#> [53] BiocBaseUtils_1.13.0 RUnit_0.4.33.1       DBI_1.2.3            cachem_1.1.0        
#> [57] chromote_0.5.1       stringr_1.6.0        rvest_1.0.5          BiocManager_1.30.27 
#> [61] vctrs_0.6.5          jsonlite_2.0.0       hms_1.1.4            bit64_4.6.0-1       
#> [65] RBGL_1.87.0          plotly_4.11.0        tidyr_1.3.1          glue_1.8.0          
#> [69] codetools_0.2-20     ps_1.9.1             DT_0.34.0            lubridate_1.9.4     
#> [73] stringi_1.8.7        gtable_0.3.6         later_1.4.4          tibble_3.3.0        
#> [77] pillar_1.11.1        rappdirs_0.3.4       htmltools_0.5.9      graph_1.89.1        
#> [81] R6_2.6.1             dbplyr_2.5.1         httr2_1.2.2          evaluate_1.0.5      
#> [85] Biobase_2.71.0       readr_2.1.6          memoise_2.0.1        httpuv_1.6.16       
#> [89] Rcpp_1.1.1           xfun_0.56            whisker_0.4.1        biocViews_1.79.0    
#> [93] pkgconfig_2.0.3
```

---
output: github_document
knit: (function(inputFile, encoding) {
  rmarkdown::render(inputFile, encoding = encoding, output_dir = "../../") })
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
    root.dir = ".",
    collapse = TRUE,
    comment = "#>",
    fig.path = "man/figures/README-",
    cache = TRUE,
    out.width = "100%"
)
```

```{r,echo=FALSE,eval=FALSE}
## Generate the ./README.md (relative to base folder)
rmarkdown::render(input = "inst/scripts/README.Rmd", output_dir = ".")
```

```{r, child="../../vignettes/BiocPkgDash.Rmd"}

```

statusServer <- function(id, data) {
    moduleServer(
        id,
        function(input, output, session) {
            output$status_out <- plotly::renderPlotly(
                BiocPkgDash::pkgStatusPlot(
                    data = data()
                )
            )
            output$status_table <- DT::renderDataTable(
                DT::datatable(
                    BiocPkgDash::pkgStatusTable(
                        data = data()
                    ),
                    escape = FALSE,
                    rownames = FALSE,
                    options = list(
                        dom = "ftp",
                        pageLength = 16,
                        lengthChange = FALSE,
                        paging = TRUE
                    )
                )
            )
        }
    )
}

statusUI <- function(id, label = "status") {
    ns <- NS(id)
    tagList(
        shinybiocloader::withLoader(
            plotly::plotlyOutput(ns("status_out")),
            loader = "biocspin"
        ),
        DT::dataTableOutput(ns("status_table"))
    )
}

.BIOC_PKG_STATUSES <- c("OK", "WARNINGS", "ERROR", "TIMEOUT", "skipped", "NA")

#' A Summary Plot for Package Statuses
#'
#' This function generates a stacked bar plot of package statuses for
#' a given Bioconductor version and email combination. It is mainly used
#' for the Bioconductor Package Dashboard.
#'
#' @details Note that binary build stages for the Linux builders are not
#'   included in the plot. This is because the binaries are built on GitHub
#'   Actions and their result are not included in the Bioconductor Build System
#'   (BBS) database.
#'
#' @param data `tibble()` / `data.frame()` A data frame of maintained packages.
#'   This is used internally to avoid repeated calls to the
#'   [BiocPkgTools::biocMaintained()] function.
#'
#' @param status `character()` A vector of `INSTALL`, `build` and `check`
#'   statuses to include in the plot. These values are obtained from the
#'   `result` column in [BiocPkgTools::biocBuildReport()]. The default is all:
#'   `c("OK", "WARNINGS", "ERROR", "TIMEOUT", "skipped")`.
#'
#' @param stage `character()` A vector of the Bioconductor Build System (BBS)
#'   stages to include in the plot. These values are obtained from the `stage`
#'   [BiocPkgTools::biocBuildReport()]. The default is all stages:
#'   `c("install", "buildsrc", "checksrc", "buildbin")`.
#'
#' @importFrom BiocPkgTools biocMaintained
#' @importFrom ggplot2 ggplot aes geom_col facet_grid coord_flip
#'   scale_fill_manual ggtitle theme element_blank
#' @importFrom dplyr full_join mutate count .data
#' @importFrom tidyr complete
#' @importFrom plotly ggplotly
#'
#' @returns An interactive `ggplotly` object.
#'
#' @examplesIf interactive()
#' data <- BiocPkgTools::biocMaintained(
#'     "maintainer@bioconductor.org", pkgType = "software"
#' )
#' pkgStatusPlot(data)
#' @export
pkgStatusPlot <- function(
    data = NULL,
    status = c("OK", "WARNINGS", "ERROR", "TIMEOUT", "skipped"),
    stage = c("install", "buildsrc", "checksrc", "buildbin")
) {
    if (missing(data))
        stop("Argument 'data' from 'biocMaintained()' is required.")
    status <- match.arg(status, several.ok = TRUE)
    stage <- match.arg(stage, several.ok = TRUE)

    pkgType <- attr(data, "pkgType")
    version <- attr(data, "version")

    pkg_type_map <- tibble::tibble(
        Package = data[["Package"]],
        PkgType = .get_pkgTypes_from_URL(data[["Package"]], version)
    )

    sdat <-
        BiocPkgTools::biocBuildStatusDB(
            version = version,
            pkgType = pkgType
        )
    names(sdat) <- c("Package", "Hostname", "Stage", "Status")

    lmain <- sdat[["Package"]] %in% data[["Package"]]
    lstage <- sdat[["Stage"]] %in% stage
    lstatus <- sdat[["Status"]] %in% status
    statusPkgs <- sdat[lmain & lstage & lstatus, ]
    if (!nrow(statusPkgs))
        stop("No packages found with specified maintainer.")

    statusPkgs <- dplyr::left_join(
        statusPkgs,
        pkg_type_map,
        by = "Package"
    )
    statusPkgs[["Stage"]] <- factor(
        statusPkgs[["Stage"]],
        levels = c("install", "buildsrc", "checksrc", "buildbin"),
        ordered = TRUE
    )
    statusPkgs[["Status"]] <- factor(
        statusPkgs[["Status"]],
        levels = .BIOC_PKG_STATUSES,
        ordered = TRUE
    )
    statusPkgs <- complete(
        statusPkgs,
        .data[["Package"]],
        .data[["Hostname"]],
        .data[["Stage"]]
    )
    statusPkgs <- full_join(
        statusPkgs,
        count(
            statusPkgs,
            .data[["Hostname"]],
            .data[["Stage"]],
            .data[["Status"]]
        ),
        by = c("Hostname", "Stage", "Status")
    )
    statusPkgs <- mutate(statusPkgs, Packages = 1)

    statusPkgs <- mutate(
        statusPkgs,
        url = ifelse(
            !is.na(.data[["Status"]]),
            paste0(
                "https://bioconductor.org/checkResults/", version, "/",
                .data[["PkgType"]], "-LATEST/", .data[["Package"]], "/",
                .data[["Hostname"]], "-", .data[["Stage"]], ".html"
            ),
            NA_character_
        )
    )

    cat_colors <-
        c('darkgreen', 'darkorange', 'darkred', 'purple', 'black', 'grey')
    names(cat_colors) <- .BIOC_PKG_STATUSES

    p <- ggplot(
        statusPkgs,
        aes(
            x = .data[["Hostname"]],
            y = .data[["Packages"]],
            label = .data[["Package"]],
            tooltip = .data[["n"]],
            customdata = .data[["url"]]
        )
    ) +
        geom_col(aes(fill = .data[["Status"]])) +
        facet_grid(. ~ .data[["Stage"]]) +
        coord_flip() +
        scale_fill_manual(values = cat_colors) +
        ggtitle(paste0("Bioconductor version ", as.character(version))) +
        theme(
            axis.text.x = element_blank(),
            axis.ticks.x = element_blank()
        )

    p_interactive <-  ggplotly(
        p, tooltip = c("label", "n", "Status", "Stage", "Hostname")
    )

    htmlwidgets::onRender(
        p_interactive,
        "
        function(el, x) {
            el.on('plotly_click', function(d) {
                // get customdata (URL) from the clicked point
                var url = d.points[0].customdata;
                // if the url exists, open it in a new tab
                if (url) {
                    window.open(url, '_blank');
                }
            });
        }
        "
    )
}

library(tinytest)
library(BiocPkgDash)
library(BiocPkgTools)

data <- biocMaintained(
    main = "maintainer@bioconductor.org",
    pkgType = "software"
)

res <- pkgStatusPlot(data = data)
expect_true(inherits(res, "plotly"))

downloadServer <- function(id, email, data) {
    moduleServer(
        id,
        function(input, output, session) {
            output$btnSend <- downloadHandler(
                filename = function() {
                    em <- gsub("@", "_", email())
                    em <- gsub("\\.", "_", em)
                    paste0("pkgdash_", em, ".html")
                },
                content = function(file) {
                    renderHTMLfrag(
                        file = file,
                        data = data()
                    )
                }
            )
        }
    )
}

downloadUI <- function(id, label = "download") {
    ns <- NS(id)
    downloadButton(
        outputId = ns("btnSend"),
        label = "Download HTML"
    )
}

.html_report_link <- function(pkg, ver, type) {
    paste0(
        paste0(
            "<a href='",
            .build_report_link(pkg, ver, type),
            "' target='_blank'>",
            pkg,
            "</a>"
        ),
        collapse = ", "
    )
}

.build_report_link <- function(pkg, ver, type) {
    paste0(
        "https://bioconductor.org/checkResults/",
        ver,
        "/",
        type,
        "-LATEST/",
        pkg,
        "/"
    )
}

depReportServer <- function(id, package_name, biocver, bioctype) {
    moduleServer(
        id,
        function(input, output, session) {
            output$dependency_ui <- renderUI({
                if (is.null(package_name())) {
                    div(
                        style =
                            "padding: 20px; text-align: center; color: #888;",
                        h4(
                            paste(
                                "Select a package from the 'Badges' tab view",
                                "its reverse dependencies."
                            )
                        )
                    )
                } else {
                    type <- .get_pkgTypes_from_URL(package_name(), biocver())
                    div(
                        style = "padding: 20px;",
                        h4(
                            HTML(
                                paste(
                                    "Reverse Dependencies for:",
                                    .html_report_link(
                                        package_name(),
                                        biocver(),
                                        type
                                    )
                                )
                            )
                        ),
                        DT::dataTableOutput(
                            session$ns("dependency_table")
                        )
                    )
                }
            })
            dependency_data <- reactive({
                req(package_name(), biocver())
                showNotification(
                    paste("Fetching dependencies for:", package_name()),
                    type = "message"
                )
                deps <- tryCatch(
                    {
                        BiocPkgTools::pkgBiocRevDeps(
                            pkg = package_name(),
                            version = biocver(),
                            pkgType = bioctype(),
                            which = "most",
                            only.bioc = TRUE
                        )
                    },
                    error = function(e) {
                        showNotification(
                            paste(
                                "Error fetching dependencies:",
                                conditionMessage(e)
                            ),
                            type = "error"
                        )
                        return(NULL)
                    }
                )
                if (is.null(deps) || !length(deps)) {
                    showNotification(
                        "No dependency data found for this package.",
                        type = "warning"
                    )
                    return(NULL)
                }
                totals <- lengths(deps)
                revdepslinks <- vapply(
                    deps,
                    function(p) {
                        if (!length(p))
                            return("")
                        type <- .get_pkgTypes_from_URL(p, biocver())
                        .html_report_link(p, biocver(), type)
                    },
                    character(1L)
                )
                deps_df <- cbind.data.frame(
                    DependencyType = c(
                        "Depends on Me",
                        "Imports Me",
                        "LinkingTo Me",
                        "Suggests Me"
                    ),
                    Packages = revdepslinks,
                    Total = totals
                )
                return(deps_df)
            })

            output$dependency_table <- DT::renderDataTable({
                req(dependency_data())
                DT::datatable(
                    dependency_data(),
                    rownames = FALSE,
                    escape = FALSE,
                    options = list(
                        pageLength = 10,
                        dom = "t"
                    )
                )
            })
        }
    )
}

depReportUI <- function(id) {
    ns <- NS(id)
    shinybiocloader::withLoader(
        uiOutput(ns("dependency_ui")),
        loader = "biocspin"
    )
}

emailServer <- function(id, email = "") {
    moduleServer(
        id,
        function(input, output, session) {
            hasEmail <- !is.null(email) && nzchar(email)
            if (!hasEmail && .config_file_exists()) {
                email <- .get_config()[["email"]]
            } else if (hasEmail && !.config_file_exists()) {
                .set_config(email = email)
            }
            emailValue <- reactiveVal(email)
            observe({
                query <- parseQueryString(session$clientData$url_search)
                if (!is.null(query[["email"]])) {
                    updateTextInput(
                        session = session,
                        inputId = "email",
                        value = query[["email"]]
                    )
                    emailValue(query[["email"]])
                } else if (!is.null(email) && nzchar(email)) {
                    updateTextInput(
                        session = session,
                        inputId = "email",
                        value = email
                    )
                    emailValue(email)
                }
            })

            observeEvent(
                input$submit_email,
                {
                    emailValue(input$email)
                    updateQueryString(
                        queryString = paste0("?email=", input$email),
                        mode = "replace",
                        session = session
                    )
                },
                priority = 1
            )
            return(
                list(
                    email = emailValue,
                    submit_email = reactive(input$submit_email)
                )
            )
        }
    )
}

emailUI <- function(id, label = "email") {
    ns <- NS(id)
    tagList(
        textInput(
            inputId = ns("email"),
            label = "Enter maintainer e-mail:",
            placeholder = "maintainer@bioconductor.org"
        ),
        actionButton(
            inputId = ns("submit_email"),
            label = "Submit",
            class = "btn-primary"
        )
    )
}

# https://community.rstudio.com/t/
# trouble-including-image-jpeg-png-svg-etc-in-shiny-app-embedded-in-r-package/
# 56156
.onLoad <- function(libname, pkgname) {
    shiny::addResourcePath(
        prefix = "images",
        directoryPath = system.file("images", package = pkgname)
    )
}

.onUnload <- function(libname, pkgname) {
    shiny::removeResourcePath("images")
}

.SHIELDS_URL <- "http://bioconductor.org/shields/build/"
.CHECK_RESULTS_URL <- "http://bioconductor.org/checkResults/"
.CODECOV_BADGE_URL <- "https://codecov.io/github/"
.CODECOV_APP_URL <- "https://app.codecov.io/github/"

filterMaintained <- function(
    data = NULL,
    cols = c(
        "Package",
        "Version",
        "License",
        "NeedsCompilation",
        "Title",
        "hasREADME",
        "hasNEWS",
        "hasINSTALL",
        "hasLICENSE",
        "dependencyCount",
        "BugReports"
    )
) {
    if (length(cols)) data <- data[, cols]
    if (!nrow(data))
        stop("No packages found")
    data[["dependencyCount"]] <- as.integer(data[["dependencyCount"]])
    data
}

badgesDF <- function(data) {
    if (missing(data))
        stop("'data' argument is required")
    version <- attr(data, "version")
    pkgTypes <- .get_pkgTypes_from_URL(data[["Package"]], version)
    versions <- c("release", "devel")
    codecov <- .get_codecov_from_BugReports(
        data[["BugReports"]], data[["Package"]]
    )

    templates <- c(
        paste0(.SHIELDS_URL, versions, "/{{pkgType}}/{{package}}.svg"),
        paste0(
            .CHECK_RESULTS_URL,
            versions,
            "/{{pkgType}}-LATEST/{{package}}"
        )
    )
    names(templates) <- c("rshield", "dshield", "rresult", "dresult")

    ## adjust for missing package types
    data <- data[match(names(pkgTypes), data[["Package"]]), ]
    urldf <- .build_urls_temp(
        packages = data[["Package"]],
        pkgType = pkgTypes,
        templates = templates
    )
    rellink <- .build_html_link(
        urldf,
        "rshield",
        "rresult",
        "release"
    )
    devlink <- .build_html_link(
        urldf,
        "dshield",
        "dresult",
        "devel"
    )

    data.frame(
        Package = data[["Package"]],
        `Bioc-release` = rellink,
        `Bioc-devel` = devlink,
        Codecov = codecov,
        row.names = NULL,
        check.names = FALSE
    )
}

#' @importFrom whisker whisker.render
.build_urls_temp <- function(packages, pkgType, templates) {
    .data <- data.frame(
        package = packages,
        pkgType = pkgType
    )
    result <- lapply(
        templates,
        function(template, tdata) {
            apply(
                tdata,
                1L,
                function(x) {
                    whisker::whisker.render(
                        template = template,
                        data = x
                    )
                }
            )
        },
        tdata = .data
    )
    cbind.data.frame(package = .data[["package"]], result)
}

renderHTMLfrag <- function(file, data = NULL) {
    version <- BiocManager:::.version_bioc(type = "devel")
    pkgType <- .get_pkgTypes_from_URL(data[["Package"]], version)

    versions <- c("release", "devel")
    templates <- c(
        paste0("https://bioconductor.org/packages/{{package}}"),
        paste0(.SHIELDS_URL, versions, "/{{pkgType}}/{{package}}.svg"),
        paste0(
            .CHECK_RESULTS_URL,
            versions,
            "/{{pkgType}}-LATEST/{{package}}"
        )
    )
    names(templates) <- c("pkgurl", "rshield", "dshield", "rresult", "dresult")
    ## adjust for missing package types
    data <- data[match(names(pkgType), data[["Package"]]), ]
    urldf <- .build_urls_temp(
        packages = data[["Package"]],
        pkgType = pkgType,
        templates = templates
    )

    datalist <- unname(split(urldf, urldf[["package"]]))
    tableTemplate <- c(
        "---",
        "title: Bioconductor Packages",
        "output: html_fragment",
        "---",
        "| Name | Bioc-release | Bioc-devel |",
        "|:-----:|:-----:|:-----:|",
        "{{#packages}}",
        paste0(
            "| [{{{package}}}]({{{pkgurl}}}) |",
            " [![Bioconductor-release Build Status]({{{rshield}}})]",
            "({{{rresult}}}) |",
            " [![Bioconductor-devel Build Status]({{{dshield}}})]",
            "({{{dresult}}}) |"
        ),
        "{{/packages}}"
    )
    rtext <- whisker::whisker.render(
        template = tableTemplate,
        data = list(packages = datalist)
    )
    mdfile <- tempfile(fileext = ".md")
    writeLines(text = rtext, con = mdfile)
    rmarkdown::render(input = mdfile, output_file = file)
}

.build_html_link <- function(.data, shieldCol, resultCol, version) {
    paste0(
        '<a href=',
        dQuote(.data[[resultCol]], q = FALSE),
        ' target="_blank">',
        '<img src=',
        dQuote(.data[[shieldCol]], q = FALSE),
        ' alt="Bioconductor-',
        version,
        ' Build Status"></a>'
    )
}

.build_codecov_badge <- function(url, owner, package) {
    imgsrc <- whisker::whisker.render(
        template = paste0(
            .CODECOV_BADGE_URL, "{{owner}}/{{package}}/graph/badge.svg"
        ),
        data = list(owner = owner, package = package)
    )
    paste0(
        '<a href=',
        dQuote(url, q = FALSE),
        ' target="_blank">',
        '<img src="', imgsrc, '"',
        ' alt="Codecov"></a>'
    )
}

pkgsServer <- function(id, reset_signal, populate_signal) {
    moduleServer(
        id,
        function(input, output, session) {
            packages <- reactiveVal(character(0L))
            observeEvent(
                input$submit_pkgs,
                {
                    if (nzchar(input$packages)) {
                        pkgs <- strsplit(input$packages, ",\\s*")[[1]]
                        parsed_pkgs <- Filter(nzchar, pkgs)
                    } else {
                        parsed_pkgs <- character(0L)
                    }
                    packages(parsed_pkgs)
                }
            )
            observeEvent(
                reset_signal(),
                {
                    updateTextAreaInput(
                        session = session,
                        inputId = "packages",
                        value = ""
                    )
                    packages(character(0L))
                }
            )
            observeEvent(
                populate_signal(),
                {
                    pkgs <- populate_signal()
                    updateTextAreaInput(
                        session = session,
                        inputId = "packages",
                        value = paste(pkgs, collapse = ", ")
                    )
                },
                ignoreInit = TRUE
            )
            return(packages)
        }
    )
}

pkgsUI <- function(id, label = "packages") {
    ns <- NS(id)
    tagList(
        textAreaInput(
            inputId = ns("packages"),
            label = "Enter package names:",
            value = "",
            placeholder = "e.g., BiocGenerics, BiocStyle, BiocBaseUtils, ...",
            rows = 4,
            width = "100%"
        ),
        actionButton(
            inputId = ns("submit_pkgs"),
            label = "Submit",
            class = "btn-primary"
        )
    )
}

# Launch the ShinyApp (Do not remove this comment)

if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

if (!requireNamespace("remotes", quietly = TRUE))
    install.packages("remotes")

options(repos = BiocManager::repositories())

if (!requireNamespace("BiocPkgDash", quietly = TRUE))
    BiocManager::install("Bioconductor/BiocPkgDash")

BiocPkgDash::BiocPkgDash(email = "maintainer@bioconductor.org") # add parameters here (if any)

.get_config_path <- function() {
    tools::R_user_dir("BiocPkgDash", which = "config")
}

.get_config_file <- function() {
    file.path(.get_config_path(), "config.yml")
}

.create_config_file <- function() {
    config_path <- .get_config_path()
    if (!dir.exists(config_path))
        dir.create(config_path, recursive = TRUE)
    config_file <- .get_config_file()
    if (!file.exists(config_file))
        file.create(config_file)
}

.get_config <- function() {
    if (file.exists(.get_config_file()))
        yaml::read_yaml(.get_config_file())
}

.set_config <- function(...) {
    config <- list(...)
    .create_config_file()
    yaml::write_yaml(config, .get_config_file())
}

.config_file_exists <- function() {
    file.exists(.get_config_file())
}

biocverServer <- function(id) {
    moduleServer(
        id,
        function(input, output, session) {
            reactive(input$biocver)
        }
    )
}

biocverUI <- function(id, label = "biocver") {
    ns <- NS(id)
    tagList(
        radioButtons(
            inputId = ns("biocver"),
            label = "Bioconductor version:",
            choices = c("release", "devel"),
            selected = "release"
        )
    )
}

ghTopicServer <- function(id, biocver) {
    moduleServer(
        id,
        function(input, output, session) {
            found_packages <- reactiveVal()
            observe({
                query <- parseQueryString(session$clientData$url_search)
                if (!is.null(query[["topic"]])) {
                    updateTextInput(
                        session = session,
                        inputId = "topic",
                        value = query[["topic"]]
                    )
                    packages <- .getBiocPackages(
                        topic = query[["topic"]],
                        version = biocver()
                    )
                    found_packages(packages)
                    pkgsval <- paste(packages, collapse = ", ")
                    updateTextAreaInput(
                        session = session,
                        inputId = "packages",
                        value = pkgsval
                    )
                }
            })
            observeEvent(input$submit_topic, {
                showModal(
                    modalDialog(
                        title = "GitHub Personal Access Token (optional)",
                        passwordInput(
                            session$ns("token_input"), "GitHub PAT:"
                        ),
                        footer = tagList(
                            modalButton("Cancel"),
                            actionButton(
                                session$ns("submit_modal"),
                                "Submit",
                                class = "btn-primary"
                            )
                        )
                    )
                )
            })
            observeEvent(input$submit_modal, {
                removeModal()
                req(input$topic)
                packages <- .getBiocPackages(
                    topic = input$topic,
                    version = biocver(),
                    token = input$token_input
                )
                found_packages(packages)
            })
            return(found_packages)
        }
    )
}

#' @importFrom BiocBaseUtils checkInstalled
.getBiocPackages <- function(topic, version, token = NULL) {
    tryCatch(
        checkInstalled("gh"),
        error = function(e) {
            msg <- conditionMessage(e)
            showNotification(
                paste(
                    "Missing dependencies are not installed; ",
                    msg
                ),
                type = "error",
                duration = 15
            )
        }
    )
    showNotification(
        paste("Searching for topic:", topic),
        type = "message",
        duration = 6
    )
    results <- gh::gh(
        "GET /search/repositories",
        q = paste0("topic:", topic),
        per_page = 100,
        token = token
    )
    repos <- vapply(results$items, `[[`, character(1L), "name")
    pkgsdb <- utils::available.packages(
        repos = BiocManager:::.repositories_bioc(version = version)
    )
    repos[repos %in% rownames(pkgsdb)]
}

ghTopicUI <- function(id, label = "topic") {
    ns <- NS(id)
    tagList(
        textInput(
            inputId = ns("topic"),
            label = "Search packages by GitHub topic:",
            value = "",
            placeholder = "e.g., u24ca289073"
        ),
        actionButton(
            inputId = ns("submit_topic"),
            label = "Search",
            class = "btn-primary"
        )
    )
}

badgesServer <- function(id, data, codecov) {
    moduleServer(
        id,
        function(input, output, session) {
            output$badge_out <- DT::renderDataTable({
                    columns_to_hide <-
                        if (codecov())
                            list(list(targets = 3, visible = FALSE))
                        else
                            list()
                DT::datatable(
                    badgesDF(
                        data = data()
                    ),
                    escape = FALSE,
                    rownames = FALSE,
                    selection = "single",
                    options = list(
                        columnDefs = columns_to_hide,
                        dom = "ftp",
                        pageLength = 20,
                        lengthChange = FALSE,
                        paging = TRUE,
                        initComplete = DT::JS(
                            "function(settings, json) {
                                Shiny.setInputValue(
                                    'badges1-badge_render_complete',
                                    Math.random()
                                );
                            }"
                        )
                    )
                )
            })
            selected_package <- reactive({
                selected_row <- input$badge_out_rows_selected
                if (length(selected_row))
                    as.character(data()[selected_row, "Package"])
                else
                    NULL
            })
            list(
                selected_package = selected_package,
                render_complete = reactive({
                    input$badge_render_complete
                })
            )
        }
    )
}

badgesUI <- function(id, label = "badges") {
    ns <- NS(id)
    tagList(
        shinybiocloader::withLoader(
            DT::dataTableOutput(ns("badge_out")),
            loader = "biocspin"
        )
    )
}

.PACKAGE_NAME <- "BiocPkgDash"

aboutPanel <- function() {
    sessionText <-
        if (requireNamespace("sessioninfo", quietly = TRUE))
            "sessioninfo::session_info()"
    else
        "utils::sessionInfo()"
    bioc_version <-
        if (requireNamespace("BiocManager", quietly = TRUE))
            as.character(BiocManager::version())
    else
        "version not available"
    pkgVer <- as.character(utils::packageVersion(.PACKAGE_NAME))
    HTML(paste0(
        h4(.PACKAGE_NAME),
        p("Package version: ", strong(pkgVer)),
        p("Bioconductor version: ", strong(bioc_version)),
        p("Last updated: ", strong("2023-12-07")),
        span("Source: ", a(
            paste0("https://github.com/Bioconductor/", .PACKAGE_NAME),
            href=paste0(
                "https://github.com/Bioconductor/", .PACKAGE_NAME
            )
        )),
        hr(),
        "<details style='margin-bottom:10px;'>", "<summary>",
        "&#9654; Session Info",
        "</summary>",
        "<pre class='r'><code>", sessionText,
        verbatimTextOutput("sessioninfo"),
        "</code></pre></details>"
    ))
}

## ----install, eval=FALSE------------------------------------------------------
# if (!requireNamespace("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# 
# BiocManager::install("BiocPkgDash")

## ----load,include=TRUE,results="hide",message=FALSE,warning=FALSE-------------
library(BiocPkgDash)

## ----display,eval=FALSE-------------------------------------------------------
# BiocPkgDash()

## ----mainapp,echo=FALSE-------------------------------------------------------
img_path <-
    if (knitr::opts_knit$get("child")) "man/figures/" else "../man/figures/"
knitr::include_graphics(paste0(img_path, "BiocPkgDash.png"))

## ----sidebarpanel,echo=FALSE--------------------------------------------------
img_path <-
    if (knitr::opts_knit$get("child")) "man/figures/" else "../man/figures/"
knitr::include_graphics(paste0(img_path, "BiocPkgDash_filter.png"))

## ----badgewall,echo=FALSE-----------------------------------------------------
img_path <-
    if (knitr::opts_knit$get("child")) "man/figures/" else "../man/figures/"
knitr::include_graphics(paste0(img_path, "BiocPkgDash_badges.png"))

## ----pkgStatus,echo=FALSE-----------------------------------------------------
img_path <-
    if (knitr::opts_knit$get("child")) "man/figures/" else "../man/figures/"
knitr::include_graphics(paste0(img_path, "BiocPkgDash_status.png"))

## ----session------------------------------------------------------------------
sessionInfo()

metadataServer <- function(id, data) {
    moduleServer(
        id,
        function(input, output, session) {
            output$metadata_out <- DT::renderDataTable({
                DT::datatable(
                    filterMaintained(
                        data = data()
                    ),
                    rownames = FALSE,
                    options = list(
                        dom = "ftp",
                        pageLength = 20,
                        paging = TRUE
                    )
                )
            })
        }
    )
}

metadataUI <- function(id, label = "metadata") {
    ns <- NS(id)
    tagList(
        shinybiocloader::withLoader(
            DT::dataTableOutput(ns("metadata_out")),
            loader = "biocspin"
        )
    )
}

codecovServer <- function(id) {
    moduleServer(
        id,
        function(input, output, session) {
            reactive(input$codecovOff)
        }
    )
}

codecovUI <- function(id, label = "codecov") {
    ns <- NS(id)
    tagList(
        checkboxInput(
            inputId = ns("codecovOff"),
            label = "Hide code coverage",
            value = FALSE
        )
    )
}

cardsServer <- function(id, data) {
    moduleServer(
        id,
        function(input, output, session) {
            output$pkg_count <- renderText({
                nrow(data())
            })

            output$dl_count <- renderText({
                all_dls <- vapply(
                    data()[["Package"]],
                    function(pkg) {
                        dl_pkg <- BiocPkgTools::pkgDownloadStats(pkg)
                        dls <- sum(dl_pkg[["Nb_of_distinct_IPs"]])
                        if (!length(dls)) 0 else dls
                    },
                    numeric(1L)
                )
                prettyNum(
                    sum(all_dls),
                    big.mark = ",",
                    scientific = FALSE
                )
            })

            output$dep_count <- renderText({
                total_deps <- vapply(
                    data()[["Package"]],
                    function(pkg) {
                        deps <- BiocPkgTools::pkgBiocDeps(
                            pkg,
                            which = "all"
                        )
                        length(unlist(deps))
                    },
                    numeric(1L)
                )
                prettyNum(
                    sum(total_deps),
                    big.mark = ",",
                    scientific = FALSE
                )
            })
        }
    )
}

cardsUI <- function(id, label = "cards") {
    ns <- NS(id)
    tagList(
        bslib::value_box(
            title = "Total Packages",
            value = textOutput(ns("pkg_count")),
            showcase = bsicons::bs_icon("hash"),
            theme = "primary"
        ),
        bslib::value_box(
            title = "Year-To-Date Downloads",
            value = textOutput(ns("dl_count")),
            showcase = bsicons::bs_icon(
                "cloud-download"
            ),
            theme = "secondary"
        ),
        bslib::value_box(
            title = "Total No. of Dependencies",
            value = textOutput(ns("dep_count")),
            showcase = bsicons::bs_icon("collection"),
            theme = "warning"
        )
    )
}

BiocPkgList <- function(packages, version = BiocManager::version()) {
    if (missing(packages))
        stop("Argument 'packages' is required.")

    pkgs <- BiocPkgTools::biocPkgList(
        version = version, addBiocViewParents = FALSE
    )

    inPkgs <- packages %in% pkgs[["Package"]]
    if (!all(inPkgs)) {
        missings <- packages[!inPkgs]
        showNotification(
            sprintf(
                "Packages not found in Bioconductor package list: %s",
                paste(missings, collapse = ", ")
            ),
            type = "warning",
            duration = 10
        )
    }

    filtered <- subset(pkgs, pkgs[["Package"]] %in% packages)
    attr(filtered, "version") <- version
    filtered
}

#' @title The Bioconductor Package Dashboard
#'
#' @description A dashboard for Bioconductor package maintainers to monitor the
#'   status of their packages. The key input to the dashboard is the email the
#'   maintainer uses in their package's `DESCRIPTION` file. The dashboard
#'   displays the badge statuses of the package in both the `release` or `devel`
#'   branches of Bioconductor. The status is determined by the results of the
#'   Bioconductor nightly builds. The dashboard also provides a visualization of
#'   the status of the package checks on either the `release` or `devel`
#'   branches of Bioconductor.
#'
#' @param email `character(1)` vector providing the email of the maintainer. By
#'   default, the package will look for the email in the URL query.
#'
#' @param ... Additional parameters to pass to the [shiny::shinyApp()] function.
#'
#' @importFrom BiocPkgTools biocMaintained
#' @import shiny
#'
#' @return called for the side effect of initializing a shiny app
#'
#' @examplesIf interactive()
#' BiocPkgDash()
#' @export
BiocPkgDash <- function(email = NULL, ...) {
    ui <- fluidPage(
        shinyjs::useShinyjs(),
        theme = bslib::bs_theme(bootswatch = "minty"),
        tags$head(
            tags$script(
                HTML(
                    "$(document).keyup(function(event) {
                        if (
                            $('#email1-email').is(':focus') &&
                                (event.key === 'Enter')
                        ) {
                            $('#email1-submit_email').click();
                        }
                    });"
                )
            )
        ),
        titlePanel(
            windowTitle = "BiocPkgDash",
            title = div(
                style = paste(
                    "display: flex;",
                    "align-items: center;",
                    "justify-content: space-between;"
                ),
                h1(id = "big-heading", "Bioconductor Package Dashboard"),
                img(
                    src = "images/bioconductor_logo_rgb_small.png"
                )
            )
        ),
        sidebarLayout(
            sidebarPanel(
                biocverUI("biocver1"),
                bioctypeUI("bioctype1"),
                emailUI("email1"),
                hr(),
                codecovUI("codecov1"),
                hr(),
                ghTopicUI("topic1"),
                hr(),
                pkgsUI("pkgs1"),
                hr(),
                HTML("Download badge wall:"),
                br(),
                downloadUI("download1"),
                width = 2
            ),
            mainPanel(
                uiOutput("email_prompt_ui"),
                div(
                    id = "dashboard_content",
                    style = "display: none;",
                    tabsetPanel(
                        tabPanel(
                            "Badges",
                            fluidRow(
                                column(width = 9, badgesUI("badges1")),
                                column(width = 3, cardsUI("cards1"))
                            )
                        ),
                        tabPanel("Status", statusUI("status1")),
                        tabPanel("Dependencies", depReportUI("report1")),
                        tabPanel("Metadata", metadataUI("data1")),
                        tabPanel("About", aboutPanel(), value = "about")
                    )
                ),
                width = 10
            )
        )
    )

    server <- function(input, output, session) {
        observe({
            query <- parseQueryString(session$clientData$url_search)
            if (!is.null(query[["email"]])) {
                updateTextInput(
                    session = session,
                    inputId = "email1-email",
                    value = query[["email"]]
                )
            } else if (!is.null(email)) {
                updateTextInput(
                    session = session,
                    inputId = "email1-email",
                    value = email
                )
            }
        })
        email_data <- emailServer("email1", email = email)
        biocver <- biocverServer("biocver1")
        codecov <- codecovServer("codecov1")
        topic_packages <- ghTopicServer("topic1", biocver = biocver)
        bioctype <- bioctypeServer("bioctype1")
        pkgs <- pkgsServer(
            "pkgs1",
            reset_signal = email_data$submit_email,
            populate_signal = topic_packages
        )

        is_email_provided <- reactive({
            !is.null(email_data$email()) && nzchar(email_data$email())
        })

        output$email_prompt_ui <- renderUI({
            if (!is_email_provided()) {
                div(
                    style = "text-align: center; margin-top: 50px;",
                    icon("envelope", "fa-5x", style = "color: #CCCCCC;"),
                    h3(
                        paste(
                            "Please enter a maintainer email in",
                            "the sidebar to see package information."
                        )
                    )
                )
            } else {
                NULL
            }
        })

        observe({
            if (is_email_provided())
                shinyjs::show("dashboard_content")
            else
                shinyjs::hide("dashboard_content")
        })

        maintainedData <- reactive({
            ## waiting for email input
            req(is_email_provided())
            ## Ensure biocver and bioctype are available
            req(biocver(), bioctype())

            p <- shiny::Progress$new()
            p$set(
                message = "Fetching package data...",
                detail = "This may take a moment",
                value = 0.5
            )
            on.exit({
                p$close()
            })
            result <- tryCatch(
                {
                    if (length(pkgs()) || length(topic_packages())) {
                        packages <- c(pkgs(), topic_packages())
                        BiocPkgList(
                            packages = packages,
                            version = biocver()
                        )
                    } else {
                        BiocPkgTools::biocMaintained(
                            main = email_data$email(),
                            version = biocver(),
                            pkgType = bioctype()
                        )
                    }
                },
                error = function(e) {
                    showNotification(
                        paste(
                            "An error occurred while fetching ",
                            "package data:",
                            e$message
                        ),
                        type = "error",
                        duration = 15
                    )
                    return(NULL)
                }
            )
            validate(
                need(
                    !is.null(result) && nrow(result),
                    paste(
                        "No packages found for that email or ",
                        "packages provided are not in Bioconductor.",
                        "\nPlease verify the email address is correct",
                        " and is associated with\npackages for the",
                        " selected Bioconductor version and",
                        " package type(s)."
                    )
                )
            )
            result
        })

        clicked_package <- badgesServer(
            "badges1",
            data = maintainedData,
            codecov = codecov
        )
        cardsServer(
            "cards1",
            data = maintainedData
        )

        downloadServer(
            "download1",
            email = email_data$email,
            data = maintainedData
        )
        depReportServer(
            "report1",
            package_name = clicked_package$selected_package,
            biocver = biocver,
            bioctype = bioctype
        )
        statusServer(
            "status1",
            data = maintainedData
        )
        metadataServer(
            "data1",
            data = maintainedData
        )

        output$sessioninfo <- renderPrint({
            if (requireNamespace("sessioninfo", quietly = TRUE))
                utils::capture.output(sessioninfo::session_info())
            else
                utils::capture.output(utils::sessionInfo())
        })
    }

    shinyApp(ui, server, ...)
}

.get_pkgTypes_from_URL <-
    function(packages, version) {
        repos <- BiocManager:::.repositories_bioc(version)
        pkgsdb <- utils::available.packages(repos = repos)
        pkgTypes <- structure(rep("bioc", length(packages)), names = packages)
        pkgs_in_db <- rownames(pkgsdb) %in% packages
        repo_urls <- pkgsdb[pkgs_in_db, "Repository"]
        tail_urls <- vapply(
            strsplit(repo_urls, paste0(version, "/")),
            "[",
            character(1L),
            2L
        )
        biocType <- gsub("/src/contrib", "", tail_urls)
        pkgTypes[names(biocType)] <- gsub("/", "-", biocType, fixed = TRUE)

        pkgsnot <- !packages %in% names(biocType)
        npkgs <- paste(packages[pkgsnot], collapse = ", ")
        if (any(pkgsnot))
            warning(
                "Bioconductor package category not found for: ",
                npkgs,
                call. = FALSE
            )
        pkgTypes
    }

.get_codecov_from_BugReports <- function(bugreports, package) {
    stopifnot(
        identical(length(bugreports), length(package))
    )
    names(bugreports) <- package
    Map(
        function(bugreplink, pkg) {
            expl <- strsplit(bugreplink, "/")[[1L]]
            owner <- expl[which(expl == "issues") - 2L]
            if (is.na(bugreplink))
                owner <- "Bioconductor"
            app_url <- paste0(
                .CODECOV_APP_URL, owner, "/", pkg
            )
            .build_codecov_badge(app_url, owner, pkg)
        },
        bugreplink = bugreports,
        pkg = package
    ) |>
        as.character()
}

.build_html_status <- function() {
    builder_url <- paste0(
        "https://bioconductor.org/checkResults/",
        "{{version}}/{{pkgType}}-LATEST/{{Package}}/",
        "{{Hostname}}-{{Stage}}.html"
    )
    paste0(
        '<a href=',
        dQuote(builder_url, q = FALSE),
        ' target="_blank">',
        '<span class="icon-status-{{Status}}">{{{svgIcon}}} {{Status}}</span>',
        '</a>'
    )
}

#' Build a table of package build statuses
#'
#' @description This function builds a table of package build statuses for a
#'  given Bioconductor version and email combination. It is mainly used for the
#'  Bioconductor Package Dashboard.
#'
#' @details Note that binary build stages for the Linux builders are marked as
#'   `skipped` in the table. This is because the binaries are built on GitHub
#'   Actions and their result are not included in the Bioconductor Build System
#'   (BBS) database. Provide the `data` argument to avoid recomputing the
#'   list of maintained packages for a given email and Bioconductor version.
#'   Annotation packages are not included in the table because they are not
#'   built regularly by the BBS.
#'
#' @param data `tibble()` / `data.frame()` A table of maintained packages.
#'   This is used internally to avoid repeated calls to the
#'   [BiocPkgTools::biocMaintained()] function.
#'
#' @param status `character()` The status of the builders to include in the
#'   table. These values are obtained from the `result` column in
#'   [BiocPkgTools::biocBuildReport()]. The default is all:
#'   `c("OK", "WARNINGS", "ERROR", "TIMEOUT", "skipped")`.
#'
#' @param stage `character()` A vector of the Bioconductor Build System (BBS)
#'   stages to include in the plot. These values are obtained from the `stage`
#'   [BiocPkgTools::biocBuildReport()]. The default is all stages:
#'   `c("install", "buildsrc", "checksrc", "buildbin")`.
#'
#' @returns A `tibble()` / `data.frame()` with the package build statuses for
#'   the given `data` input.
#'
#' @examplesIf interactive()
#' data <- BiocPkgTools::biocMaintained("maintainer@bioconductor.org")
#' pkgStatusTable(data)
#' @export
pkgStatusTable <- function(
    data = NULL,
    status = c("OK", "WARNINGS", "ERROR", "TIMEOUT", "skipped"),
    stage = c("install", "buildsrc", "checksrc", "buildbin")
) {
    if (missing(data))
        stop("Argument 'data' from 'biocMaintained()' is required.")

    status <- match.arg(status, several.ok = TRUE)
    stage <- match.arg(stage, several.ok = TRUE)

    pkgType <- attr(data, "pkgType")
    version <- attr(data, "version")

    biocTypes <- .get_pkgTypes_from_URL(data[["Package"]], version)
    ## adjust for missing package types
    data <- data[match(names(biocTypes), data[["Package"]]), ]
    data <- dplyr::bind_cols(data, pkgType = biocTypes)
    sdat <-
        BiocPkgTools::biocBuildStatusDB(
            version = version,
            pkgType = pkgType
        )
    names(sdat) <- c("Package", "Hostname", "Stage", "Status")

    lmain <- sdat[["Package"]] %in% data[["Package"]]
    lstage <- sdat[["Stage"]] %in% stage
    lstatus <- sdat[["Status"]] %in% status
    statusPkgs <- sdat[lmain & lstage & lstatus, ]
    if (!length(statusPkgs))
        stop("No packages found with specified maintainer.")

    statusPkgs[["Stage"]] <- factor(
        statusPkgs[["Stage"]],
        levels = c("install", "buildsrc", "checksrc", "buildbin"),
        ordered = TRUE
    )
    statusPkgs[["Status"]] <- factor(
        statusPkgs[["Status"]],
        levels = .BIOC_PKG_STATUSES,
        ordered = TRUE
    )
    statusPkgs <- tidyr::complete(
        statusPkgs,
        .data[["Package"]],
        .data[["Hostname"]],
        .data[["Stage"]]
    )

    statusPkgs <- dplyr::left_join(
        statusPkgs,
        data[, c("Package", "pkgType")],
        by = c("Package" = "Package")
    )
    statusPkgs[["StageLabel"]] <- factor(
        statusPkgs[["Stage"]],
        levels = c("install", "buildsrc", "checksrc", "buildbin"),
        labels = c(
            "Install",
            "Build Source",
            "Check Source",
            "Build Binary"
        ),
        ordered = TRUE
    )
    glyphSuffix <- factor(
        statusPkgs[["Status"]],
        levels = c("ERROR", "WARNINGS", "TIMEOUT", "OK", "skipped", "NA"),
        labels = c(
            "x-circle",
            "exclamation-circle",
            "clock",
            "check2-circle",
            "dash-circle",
            "question-circle"
        ),
        ordered = FALSE
    )
    glyphSuffix[is.na(glyphSuffix)] <- "question-circle"
    statusPkgs <- dplyr::bind_cols(statusPkgs, glyphSuffix = glyphSuffix)
    statusPkgs[["Status"]][is.na(statusPkgs[["Status"]])] <- "NA"
    statusPkgs[["svgIcon"]] <- vapply(
        statusPkgs[["glyphSuffix"]],
        function(x) as.character(bsicons::bs_icon(x)),
        character(1L)
    )

    build_urls <- apply(
        statusPkgs,
        1L,
        function(x, ver) {
            whisker::whisker.render(
                template = .build_html_status(),
                data = c(as.list(x), version = ver)
            )
        },
        ver = as.character(version)
    )
    statusPkgs[["build_url"]] <- build_urls

    dplyr::select(
        statusPkgs,
        "Package",
        "Hostname",
        "StageLabel",
        "build_url"
    ) |>
        tidyr::pivot_wider(
            names_from = "StageLabel",
            values_from = "build_url",
            values_fn = unique
        )
}

data <- biocMaintained(
    main = "maintainer@bioconductor.org",
    pkgType = "software"
)

res <- pkgStatusTable(data)
expect_true(inherits(res, "tbl_df"))
packages <- res[["Package"]] |> unique()
expect_true(
    packages |>
        length() > 20
)
expect_true(
    all(
        c(
            "Package", "Hostname", "Install",
            "Build Source", "Check Source", "Build Binary"
        ) %in% colnames(res)
    )
)

expect_true(
    "BiocVersion" %in% packages
)

bioctypeServer <- function(id) {
    moduleServer(
        id,
        function(input, output, session) {
            reactive(input$bioctype)
        }
    )
}

bioctypeUI <- function(id, label = "bioctype") {
    ns <- NS(id)
    tagList(
        checkboxGroupInput(
            inputId = ns("bioctype"),
            label = "Bioconductor package type:",
            choices = c(
                "software",
                "data-experiment",
                "data-annotation",
                "workflows"
            ),
            selected = "software"
        )
    )
}

---
title: "Bioconductor Package Dashboard"
author: 
- name: Marcel Ramos
  affiliation: >
    CUNY Graduate School of Public Health and Health Policy, New York, NY USA
output: BiocStyle::html_document
date: "`r format(Sys.time(), '%B %d, %Y')`"
vignette: >
  %\VignetteIndexEntry{Bioconductor Package Dashboard Intro}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
package: BiocPkgDash
---

# BiocPkgDash

# Introduction

The BiocPkgDash package provides an interactive Shiny application to visualize
the status of Bioconductor packages. Primarily, users can filter packages by
maintainer email to display a status badge wall for all packages maintained by
that email. It allows users to filter packages based on various criteria, such
as Bioconductor version, package type, and GitHub topics. The dashboard displays
badges indicating the build status and code coverage for each package. The
tool is primarily designed for Bioconductor package maintainers to monitor the
status of their packages.

## Comparison to Bioconductor Build Results

The Bioconductor Build Results [page](https://bioconductor.org/checkResults)
provides a comprehensive overview of the build status of all Bioconductor
packages. However, it can be overwhelming for maintainers who are only
interested in the status of their own packages. The `BiocPkgDash` dashboard
provides a more focused view of the status of packages maintained by a specific
email, allowing maintainers to quickly identify any issues with their packages
without having to navigate through the entire list of packages on the Build
Results page.

Users can quickly go the relevant section in the Bioconductor Build Results
page by clicking on the badges or the status bars in the dashboard. This allows
maintainers to easily access more detailed information about the build status
of their packages.

# Installation

```{r install, eval=FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("BiocPkgDash")
```

# Loading

```{r load,include=TRUE,results="hide",message=FALSE,warning=FALSE}
library(BiocPkgDash)
```

Note that the app uses `r BiocStyle::Biocpkg("BiocPkgTools")` to download
package information from the Bioconductor Build System (BBS) database. This is
required for the app to function properly and can be safely created. The prompt
may look like the following (path varies by operating system):

```
/Users/user/.cache/R/BiocFileCache
    does not exist, create directory? (yes/no): yes
```

Create the cache directory by entering `yes` and pressing `Enter`.

# Dashboard display

```{r display,eval=FALSE}
BiocPkgDash()
```

```{r mainapp,echo=FALSE}
img_path <-
    if (knitr::opts_knit$get("child")) "man/figures/" else "../man/figures/"
knitr::include_graphics(paste0(img_path, "BiocPkgDash.png"))
```

Note that the dashboard and this document is organized by the tab panels.
Each tab in the dashboard is described in the following sections.

## Filtering packages

One can filter packages by name, Bioconductor version, biocViews package type,
maintainer email, and GitHub topics. The dashboard will display the status
badges for all packages that match the selected criteria. Typically, a user
with use one of the methods to filter for packages. Primarily, the user will
filter by the relevant maintainer email.

```{r sidebarpanel,echo=FALSE}
img_path <-
    if (knitr::opts_knit$get("child")) "man/figures/" else "../man/figures/"
knitr::include_graphics(paste0(img_path, "BiocPkgDash_filter.png"))
```

### GitHub topic filter

The GitHub topic filter allows users to filter packages based on specific
topics associated with R / Bioconductor packages on GitHub. This can be useful
for organizations that maintain multiple packages related to a specific
project, theme, or grant. For example, one can filter for all packages related
to a particular grant code, e.g., "u24ca289073". Note that repositories will
have to have the topic added to them for the filter to work.

# Badges

The badge wall displays the build status and code coverage for each package.
Clicking on a badge will take you to the relevant page for more details.

```{r badgewall,echo=FALSE}
img_path <-
    if (knitr::opts_knit$get("child")) "man/figures/" else "../man/figures/"
knitr::include_graphics(paste0(img_path, "BiocPkgDash_badges.png"))
```

Note that the coverage badges can be turned off if the maintainer does not use
codecov.io for testing package coverage.

## Downloading the badge wall

The dashboard allows users to download the badge wall as a partial HTML file.
This can be useful for including the badges on personal websites or other
HTML documentation. The HTML file is generated on the fly by the `shiny` app
after clicking the `Download HTML` button on the sidebar panel.

# Status

The dashboard also provides a visualization of the package build statuses
across different stages of the Bioconductor Build System (BBS). This helps
maintainers quickly identify any issues with their packages.

```{r pkgStatus,echo=FALSE}
img_path <-
    if (knitr::opts_knit$get("child")) "man/figures/" else "../man/figures/"
knitr::include_graphics(paste0(img_path, "BiocPkgDash_status.png"))
```

Note that clicking on any of the status bars in the plot takes the user to
the detailed build report for that specific builder, stage, and status
combination.

# Dependencies

The `Dependencies` tab displays the package reverse dependencies for a selected
package. This can help maintainers understand the dependency tree of their
packages and identify any potential issues.

# Metadata

The `Metadata` tab displays additional information about the selected package(s)
such as the package title, version, and additional fields from the `DESCRIPTION`
file as obtained from the internal `biocViews` database. This can help
maintainers quickly access information about their package(s).

# Session Information

```{r session}
sessionInfo()
```

---
title: "Bioconductor Package Dashboard"
format:
  dashboard:
    orientation: columns
logo: https://bioconductor.org/images/logo_bioconductor.gif
theme: minty
server: shiny
---

```{r}
#| context: setup
#| include: false

library(BiocPkgDash)
```

```{r}
#| context: data
#| include: false

version <- BiocManager:::.version_bioc(type = "release")
data <- BiocPkgTools::biocMaintained(
    main = "maintainer@bioconductor.org",
    version = version,
    pkgType = "software"
)
pkgs <-  BiocPkgDash:::filterMaintained(
    data = data
)
```


# {.sidebar}

```{r}
radioButtons(
    inputId = "biocver",
    label = "Bioconductor version:",
    choices = c("release", "devel"),
    selected = "release"
)
checkboxGroupInput(
    inputId = "bioctype",
    label = "Bioconductor package type:",
    choices = c(
        "software",
        "data-experiment",
        "data-annotation",
        "workflows"
    ),
    selected = "software"
)
textInput(
    inputId = "email",
    label = "Enter maintainer e-mail",
    placeholder = "maintainer@bioconductor.org"
)
actionButton(
    inputId = "submit",
    label = "Submit",
    class = "btn-primary"
)
```

-------------------------------------------------------------------------------

Download the badge wall as an HTML fragment for your website:

```{r}
#| output: asis

## downloadButton currently not working
## https://github.com/quarto-dev/quarto-cli/issues/999
## using workaround
## https://github.com/rstudio/shiny/issues/2392#issuecomment-484097398
(downloadButton(
    outputId = "btnSend",
    label = "Download HTML"
))
```

# Badges

## Column {width="80%"}

```{r}
#| title: Wall of Badges
DT::dataTableOutput("badge_out")
```

## Column {width="20%"}


```{r}
bslib::value_box(
    title = "Total Packages",
    value = textOutput("pkg_count"),
    showcase = bsicons::bs_icon("hash"),
    theme = "primary"
)
```

```{r}
bslib::value_box(
    title = "Year-To-Date Downloads",
    value = textOutput("dl_count"),
    showcase = bsicons::bs_icon("cloud-download"),
    theme = "secondary"
)
```

```{r}
bslib::value_box(
    title = "Total No. of Dependencies",
    value = textOutput("dep_count"),
    showcase = bsicons::bs_icon("collection"),
    theme = "warning"
)
```

# Status

## Column {width="80%"}

```{r}
#| title: Package Status Plot
plotly::plotlyOutput("status_out")
```

# Data

## Column {height="80%"}

```{r}
#| title: Packages Maintained
DT::dataTableOutput("data_out")
```

# Status Table

## Column {height="80%"}

```{r}
#| title: Package Status Table
DT::dataTableOutput("status_table")
```


```{r}
#| context: server
emailValue <- reactiveVal("maintainer@bioconductor.org")

main_data <- reactive({
    if (
        emailValue() %in%
            c("maintainer@bioconductor\\.org", "maintainer@bioconductor.org")
    )
        pkgs
    else
        BiocPkgDash:::renderMaintained(
            email = emailValue(),
            version = input$biocver,
            pkgType = input$bioctype
        )
})

output$pkg_count <- renderText({
    nrow(main_data())
})

observeEvent(input$submit, {
    emailValue(input[["email"]])
})

output$badge_out <- DT::renderDataTable({
    DT::datatable(
        BiocPkgDash:::badgesDF(
            data = main_data()
        ),
        escape = FALSE,
        rownames = FALSE,
        options = list(
            dom = "ftp",
            pageLength = 20,
            lengthChange = FALSE,
            paging = TRUE
        )
    )
})

output$btnSend <- downloadHandler(
    filename = function() {
        em <- gsub("@", "_at_", emailValue())
        em <- gsub("\\.", "_dot_", em)
        paste0(em, ".html")
    },
    content = function(file) {
        BiocPkgDash:::renderHTMLfrag(
            file = file, data = main_data()
        )
    }
)

output$data_out <- DT::renderDataTable({
    DT::datatable(
        main_data()[, c(
            "Package", "Version", "License", "NeedsCompilation", "Title",
            "hasREADME", "hasNEWS", "hasINSTALL", "hasLICENSE",
            "dependencyCount"
        )],
        rownames = FALSE,
        options = list(
            dom = "ftp",
            pageLength = 20,
            paging = TRUE
        )
    )
})

output$status_out <- plotly::renderPlotly(
    BiocPkgDash::pkgStatusPlot(
        data = main_data()
    )
)

output$status_table <- DT::renderDataTable({
    DT::datatable(
        BiocPkgDash::pkgStatusTable(
            data = main_data()
        ),
        escape = FALSE,
        rownames = FALSE,
        options = list(
            dom = "ftp",
            pageLength = 20,
            lengthChange = FALSE,
            paging = TRUE
        )
    )
})

output$dl_count <- renderText({
    all_dls <- vapply(
        main_data()$Package,
        function(pkg) {
            dl_pkg <- suppressWarnings({
                BiocPkgTools::pkgDownloadStats(pkg)
            })
            dls <- sum(dl_pkg[["Nb_of_distinct_IPs"]])
            if (!length(dls))
                0
            else
                dls
        },
        numeric(1L)
    )
    prettyNum(
        sum(all_dls),
        big.mark = ",",
        scientific = FALSE
    )
})

output$dep_count <- renderText({
    total_deps <- vapply(
        main_data()$Package,
        function(pkg) {
            deps <- BiocPkgTools::pkgBiocDeps(
                pkg,
                which = "all"
            )
            length(unlist(deps))
        },
        numeric(1L)
    )
    prettyNum(
        sum(total_deps),
        big.mark = ",",
        scientific = FALSE
    )
})

```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pkgStatusTable.R
\name{pkgStatusTable}
\alias{pkgStatusTable}
\title{Build a table of package build statuses}
\usage{
pkgStatusTable(
  data = NULL,
  status = c("OK", "WARNINGS", "ERROR", "TIMEOUT", "skipped"),
  stage = c("install", "buildsrc", "checksrc", "buildbin")
)
}
\arguments{
\item{data}{\code{tibble()} / \code{data.frame()} A table of maintained packages.
This is used internally to avoid repeated calls to the
\code{\link[BiocPkgTools:biocMaintained]{BiocPkgTools::biocMaintained()}} function.}

\item{status}{\code{character()} The status of the builders to include in the
table. These values are obtained from the \code{result} column in
\code{\link[BiocPkgTools:biocBuildReport]{BiocPkgTools::biocBuildReport()}}. The default is all:
\code{c("OK", "WARNINGS", "ERROR", "TIMEOUT", "skipped")}.}

\item{stage}{\code{character()} A vector of the Bioconductor Build System (BBS)
stages to include in the plot. These values are obtained from the \code{stage}
\code{\link[BiocPkgTools:biocBuildReport]{BiocPkgTools::biocBuildReport()}}. The default is all stages:
\code{c("install", "buildsrc", "checksrc", "buildbin")}.}
}
\value{
A \code{tibble()} / \code{data.frame()} with the package build statuses for
the given \code{data} input.
}
\description{
This function builds a table of package build statuses for a
given Bioconductor version and email combination. It is mainly used for the
Bioconductor Package Dashboard.
}
\details{
Note that binary build stages for the Linux builders are marked as
\code{skipped} in the table. This is because the binaries are built on GitHub
Actions and their result are not included in the Bioconductor Build System
(BBS) database. Provide the \code{data} argument to avoid recomputing the
list of maintained packages for a given email and Bioconductor version.
Annotation packages are not included in the table because they are not
built regularly by the BBS.
}
\examples{
\dontshow{if (interactive()) withAutoprint(\{ # examplesIf}
data <- BiocPkgTools::biocMaintained("maintainer@bioconductor.org")
pkgStatusTable(data)
\dontshow{\}) # examplesIf}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pkgStatusPlot.R
\name{pkgStatusPlot}
\alias{pkgStatusPlot}
\title{A Summary Plot for Package Statuses}
\usage{
pkgStatusPlot(
  data = NULL,
  status = c("OK", "WARNINGS", "ERROR", "TIMEOUT", "skipped"),
  stage = c("install", "buildsrc", "checksrc", "buildbin")
)
}
\arguments{
\item{data}{\code{tibble()} / \code{data.frame()} A data frame of maintained packages.
This is used internally to avoid repeated calls to the
\code{\link[BiocPkgTools:biocMaintained]{BiocPkgTools::biocMaintained()}} function.}

\item{status}{\code{character()} A vector of \code{INSTALL}, \code{build} and \code{check}
statuses to include in the plot. These values are obtained from the
\code{result} column in \code{\link[BiocPkgTools:biocBuildReport]{BiocPkgTools::biocBuildReport()}}. The default is all:
\code{c("OK", "WARNINGS", "ERROR", "TIMEOUT", "skipped")}.}

\item{stage}{\code{character()} A vector of the Bioconductor Build System (BBS)
stages to include in the plot. These values are obtained from the \code{stage}
\code{\link[BiocPkgTools:biocBuildReport]{BiocPkgTools::biocBuildReport()}}. The default is all stages:
\code{c("install", "buildsrc", "checksrc", "buildbin")}.}
}
\value{
An interactive \code{ggplotly} object.
}
\description{
This function generates a stacked bar plot of package statuses for
a given Bioconductor version and email combination. It is mainly used
for the Bioconductor Package Dashboard.
}
\details{
Note that binary build stages for the Linux builders are not
included in the plot. This is because the binaries are built on GitHub
Actions and their result are not included in the Bioconductor Build System
(BBS) database.
}
\examples{
\dontshow{if (interactive()) withAutoprint(\{ # examplesIf}
data <- BiocPkgTools::biocMaintained(
    "maintainer@bioconductor.org", pkgType = "software"
)
pkgStatusPlot(data)
\dontshow{\}) # examplesIf}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/BiocPkgDash.R
\name{BiocPkgDash}
\alias{BiocPkgDash}
\title{The Bioconductor Package Dashboard}
\usage{
BiocPkgDash(email = NULL, ...)
}
\arguments{
\item{email}{\code{character(1)} vector providing the email of the maintainer. By
default, the package will look for the email in the URL query.}

\item{...}{Additional parameters to pass to the \code{\link[shiny:shinyApp]{shiny::shinyApp()}} function.}
}
\value{
called for the side effect of initializing a shiny app
}
\description{
A dashboard for Bioconductor package maintainers to monitor the
status of their packages. The key input to the dashboard is the email the
maintainer uses in their package's \code{DESCRIPTION} file. The dashboard
displays the badge statuses of the package in both the \code{release} or \code{devel}
branches of Bioconductor. The status is determined by the results of the
Bioconductor nightly builds. The dashboard also provides a visualization of
the status of the package checks on either the \code{release} or \code{devel}
branches of Bioconductor.
}
\examples{
\dontshow{if (interactive()) withAutoprint(\{ # examplesIf}
BiocPkgDash()
\dontshow{\}) # examplesIf}
}
